# 小程序支付 Server SDK 使用向导

## 运行DEMO

1. 下载，安装并正确设置Java（注意环境变量的设置）

2. 下载头条小程序支付Server SDK，解压

3. 使用eclipse导入小程序支付Server SDK Maven 项目 `ttpay_server_sdk`，运行项目

4. 项目运行结果


- 签名原串（方便拉起收银台报签名错误时，排查问题）

```
SignUtil.sign debug signStr:alipay_url=alipay_sdk=alipay-sdk-java-4.8.73.ALL&app_id=2019022763436277&biz_content=%7B%22body%22%3A%22%E5%A7%93%E5%90%8D%E5%A5%91%E5%90%88%E5%BA%A6%E9%85%8D%E5%AF%B9%22%2C%22out_trade_no%22%3A%225eba96cfb3b7c63c3beaac11%22%2C%22product_code%22%3A%22QUICK_MSECURITY_PAY%22%2C%22subject%22%3A%22%E5%A7%93%E5%90%8D%E5%A5%91%E5%90%88%E5%BA%A6%E9%85%8D%E5%AF%B9%22%2C%22timeout_express%22%3A%2260m%22%2C%22total_amount%22%3A%221%22%7D&charset=utf-8&format=json&method=alipay.trade.app.pay&notify_url=https%3A%2F%2Fwww.adota.cn%2Fwxpro%2Fpay%2Fali%2Fcallback&sign=LWCZVmaUQIjAqlkY0yHzgHIn6H8O3G3l%2FrJKW4s3aEpeneRcR8P8Ek2DbnSXBaegD7ifbkRmm1%2FE%2BYPccjR2PKSp5EIe2zbQFYt83QguPzO4ZAhwaOFCwpuO%2BHy2mt1uqtZ8iszzL8BTwBKjA76p3D53NWdBaIETl9sNnJuwU0u%2FNREcWVVDHR0Mr7tJWgo9MwpYEv%2BEBwxEGuKvFkwQ6IWQT3bBP58V8TTzrMsqPDerQaXEzXslJWeeYKqcnPdsu%2FjUNETz5LWjKB5rxjLuldUXt0UWxWuAXTACe3WOeDI0M7Qg1o7rY3eEBpRKxgaAHf1uHUZVUo4ayndDEBtVsw%3D%3D&sign_type=RSA2&timestamp=2020-05-12+20%3A30%3A07&version=1.0&app_id=800000057774&body=gogokid精品课，56节&currency=CNY&merchant_id=1300000005&notify_url=https://www.toutiao.com&out_order_no=1589339570395&payment_type=direct&product_code=pay&sign_type=MD5&subject=gogokid精品课&timestamp=1589339570&total_amount=1&trade_time=1589339570&trade_type=H5&uid=111313185055&valid_time=36000000&version=2.0&wx_type=MWEB&wx_url=https://wx.tenpay.com/cgi-bin/mmpayweb-bin/checkmweb?prepay_id=wx12203020777710874a3578888880278600&package=2202098580

```

- 生成的orderInfo参数，将生成的JSON结构数据直接透传给前端，作为tt.pay的orderInfo参数值

```
tt.pay's orderInfo params: {"trade_time":"1589339570","wx_type":"MWEB","subject":"gogokid精品课","sign":"bbe1d524316b065eb832daedf60bcefc","out_order_no":"1589339570395","wx_url":"https://wx.tenpay.com/cgi-bin/mmpayweb-bin/checkmweb?prepay_id\u003dwx12203020777710874a3578888880278600\u0026package\u003d2202098580","merchant_id":"1300000005","product_code":"pay","notify_url":"https://www.toutiao.com","body":"gogokid精品课，56节","version":"2.0","uid":"111313185055","payment_type":"direct","total_amount":"1","trade_type":"H5","currency":"CNY","risk_info":"{\"ip\":\"100.120.154.110\"}","valid_time":"36000000","app_id":"800000057774","sign_type":"MD5","alipay_url":"alipay_sdk\u003dalipay-sdk-java-4.8.73.ALL\u0026app_id\u003d2019022763436277\u0026biz_content\u003d%7B%22body%22%3A%22%E5%A7%93%E5%90%8D%E5%A5%91%E5%90%88%E5%BA%A6%E9%85%8D%E5%AF%B9%22%2C%22out_trade_no%22%3A%225eba96cfb3b7c63c3beaac11%22%2C%22product_code%22%3A%22QUICK_MSECURITY_PAY%22%2C%22subject%22%3A%22%E5%A7%93%E5%90%8D%E5%A5%91%E5%90%88%E5%BA%A6%E9%85%8D%E5%AF%B9%22%2C%22timeout_express%22%3A%2260m%22%2C%22total_amount%22%3A%221%22%7D\u0026charset\u003dutf-8\u0026format\u003djson\u0026method\u003dalipay.trade.app.pay\u0026notify_url\u003dhttps%3A%2F%2Fwww.adota.cn%2Fwxpro%2Fpay%2Fali%2Fcallback\u0026sign\u003dLWCZVmaUQIjAqlkY0yHzgHIn6H8O3G3l%2FrJKW4s3aEpeneRcR8P8Ek2DbnSXBaegD7ifbkRmm1%2FE%2BYPccjR2PKSp5EIe2zbQFYt83QguPzO4ZAhwaOFCwpuO%2BHy2mt1uqtZ8iszzL8BTwBKjA76p3D53NWdBaIETl9sNnJuwU0u%2FNREcWVVDHR0Mr7tJWgo9MwpYEv%2BEBwxEGuKvFkwQ6IWQT3bBP58V8TTzrMsqPDerQaXEzXslJWeeYKqcnPdsu%2FjUNETz5LWjKB5rxjLuldUXt0UWxWuAXTACe3WOeDI0M7Qg1o7rY3eEBpRKxgaAHf1uHUZVUo4ayndDEBtVsw%3D%3D\u0026sign_type\u003dRSA2\u0026timestamp\u003d2020-05-12+20%3A30%3A07\u0026version\u003d1.0","timestamp":"1589339570"}
```


## 开发者项目中使用

#####1. 在项目工程中新建 `lib` 文件夹

#####2. 将 `ttpay_server_sdk/lib/tt_pay-1.0.5.jar` 拷贝到新建的lib文件夹下

#####3. 配置编译路径
	

- 	打开配置编译路径弹窗

![alt 配置编译路径](https://sf3-ttcdn-tos.pstatp.com/obj/static-assets/502105c20c767a21f10d749ccb25dc88.png)

- 将拷贝到项目lib目录下的 `tt_pay-1.0.5.jar` 包，添加到Libraries下

![alt 添加jar包](https://sf1-ttcdn-tos.pstatp.com/obj/static-assets/ab2946b1d0d3833551f319b8aff4eab8.png)


#####4. 配置pom.xml依赖

将以下依赖添加到开发者项目的`pom.xml`中

```
<dependencies>
   	<dependency>
		<groupId>commons-codec</groupId>
		<artifactId>commons-codec</artifactId>
		<version>1.6</version>
	</dependency>
	<dependency>
      <groupId>com.google.code.gson</groupId>
      <artifactId>gson</artifactId>
      <version>2.2.4</version>
    </dependency>
</dependencies>
```


#####5. 参照`MicroAppDemo.java`中DEMO，生成前端调用 `tt.pay` 所需的参数 `orderInfo`


